Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 7567)
@@ -54,9 +54,10 @@
   PUBLIC   dia_dct      ! routine called by step.F90
   PUBLIC   dia_dct_init ! routine called by opa.F90
-  PUBLIC   diadct_alloc ! routine called by nemo_init in nemogcm.F90 
+  PUBLIC   diadct_alloc ! routine called by nemo_init in nemogcm.F90
   PRIVATE  readsec
   PRIVATE  removepoints
   PRIVATE  transport
   PRIVATE  dia_dct_wri
+  PRIVATE  dia_dct_wri_NOOS
 
 #include "domzgr_substitute.h90"
@@ -69,11 +70,13 @@
   INTEGER :: nn_dctwri     ! Frequency of output
   INTEGER :: nn_secdebug   ! Number of the section to debug
+  INTEGER :: nn_dct_h    = 1     ! Frequency of computation for NOOS hourly files
+  INTEGER :: nn_dctwri_h = 1     ! Frequency of output for NOOS hourly files
    
-  INTEGER, PARAMETER :: nb_class_max  = 10
-  INTEGER, PARAMETER :: nb_sec_max    = 150
-  INTEGER, PARAMETER :: nb_point_max  = 2000
-  INTEGER, PARAMETER :: nb_type_class = 10
-  INTEGER, PARAMETER :: nb_3d_vars    = 3 
-  INTEGER, PARAMETER :: nb_2d_vars    = 2 
+  INTEGER, PARAMETER :: nb_class_max  = 11   ! maximum number of classes, i.e. depth levels or density classes
+  INTEGER, PARAMETER :: nb_sec_max    = 30   ! maximum number of sections
+  INTEGER, PARAMETER :: nb_point_max  = 375  ! maximum number of points in a single section
+  INTEGER, PARAMETER :: nb_type       = 14   ! types of calculations, i.e. pos transport, neg transport, heat transport, salt transport
+  INTEGER, PARAMETER :: nb_3d_vars    = 5
+  INTEGER, PARAMETER :: nb_2d_vars    = 2
   INTEGER            :: nb_sec 
 
@@ -101,5 +104,6 @@
                                                      ztem            ,&! temperature classes(99 if you don't want)
                                                      zlay              ! level classes      (99 if you don't want)
-     REAL(wp), DIMENSION(nb_type_class,nb_class_max)  :: transport     ! transport output
+     REAL(wp), DIMENSION(nb_type,nb_class_max)        :: transport     ! transport output
+     REAL(wp), DIMENSION(nb_type,nb_class_max)        :: transport_h   ! transport output
      REAL(wp)                                         :: slopeSection  ! slope of the section
      INTEGER                                          :: nb_point      ! number of points in the section
@@ -108,26 +112,32 @@
 
   TYPE(SECTION),DIMENSION(nb_sec_max) :: secs ! Array of sections
- 
-  REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  transports_3d 
-  REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::  transports_2d  
+
+  REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  transports_3d
+  REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::  transports_2d
+  REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  transports_3d_h
+  REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::  transports_2d_h
+  REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::  z_hr_output
 
    !! $Id$
 CONTAINS
 
- 
-  INTEGER FUNCTION diadct_alloc() 
-     !!---------------------------------------------------------------------- 
-     !!                   ***  FUNCTION diadct_alloc  *** 
-     !!---------------------------------------------------------------------- 
-     INTEGER :: ierr(2) 
-     !!---------------------------------------------------------------------- 
-
-     ALLOCATE(transports_3d(nb_3d_vars,nb_sec_max,nb_point_max,jpk), STAT=ierr(1) ) 
-     ALLOCATE(transports_2d(nb_2d_vars,nb_sec_max,nb_point_max)    , STAT=ierr(2) ) 
-
-     diadct_alloc = MAXVAL( ierr ) 
-     IF( diadct_alloc /= 0 )   CALL ctl_warn('diadct_alloc: failed to allocate arrays') 
- 
-  END FUNCTION diadct_alloc 
+  INTEGER FUNCTION diadct_alloc()
+     !!--------------------------------------------------------------------nb_sec--
+     !!                   ***  FUNCTION diadct_alloc  ***
+     !!----------------------------------------------------------------------
+     INTEGER :: ierr(2)
+     !!----------------------------------------------------------------------
+     !
+     ALLOCATE(transports_3d(nb_3d_vars,nb_sec_max,nb_point_max,jpk),   STAT=ierr(1) )
+     ALLOCATE(transports_2d(nb_2d_vars,nb_sec_max,nb_point_max)    ,   STAT=ierr(2) )
+     ALLOCATE(transports_3d_h(nb_3d_vars,nb_sec_max,nb_point_max,jpk), STAT=ierr(3) )
+     ALLOCATE(transports_2d_h(nb_2d_vars,nb_sec_max,nb_point_max)    , STAT=ierr(4) )
+     ALLOCATE(z_hr_output(nb_sec_max,24,nb_class_max)                , STAT=ierr(5) )
+        !
+     diadct_alloc = MAXVAL( ierr )
+     IF( diadct_alloc /= 0 )   CALL ctl_warn('diadct_alloc: failed to allocate arrays')
+     !
+  END FUNCTION diadct_alloc
+
 
   SUBROUTINE dia_dct_init
@@ -152,4 +162,26 @@
 902  IF( ios /= 0 ) CALL ctl_nam ( ios , 'namdct in configuration namelist', lwp )
      IF(lwm) WRITE ( numond, namdct )
+     
+     
+     
+     
+     
+     
+     
+     
+     !NAMELIST/namdct/nn_dct,nn_dctwri,nn_secdebug
+
+     !IF( nn_timing == 1 )   CALL timing_start('dia_dct_init')
+
+     !read namelist
+     !REWIND( numnam )
+     !READ  ( numnam, namdct )
+
+     IF( ln_NOOS ) THEN
+        nn_dct=3600./rdt         ! hard coded for NOOS transects, to give 25 hour means 
+        nn_dctwri=86400./rdt
+        nn_dct_h=1       ! hard coded for NOOS transects, to give hourly data
+        nn_dctwri_h=3600./rdt
+     ENDIF
 
      IF( lwp ) THEN
@@ -157,6 +189,13 @@
         WRITE(numout,*) "diadct_init: compute transports through sections "
         WRITE(numout,*) "~~~~~~~~~~~~~~~~~~~~~"
-        WRITE(numout,*) "       Frequency of computation: nn_dct    = ",nn_dct
-        WRITE(numout,*) "       Frequency of write:       nn_dctwri = ",nn_dctwri
+        IF( ln_NOOS ) THEN
+           WRITE(numout,*) "       Frequency of computation hard coded to be every hour: nn_dct    = ",nn_dct
+           WRITE(numout,*) "       Frequency of write hard coded to average 25 instantaneous hour values: nn_dctwri = ",nn_dctwri
+           WRITE(numout,*) "       Frequency of hourly computation hard coded to be every timestep: nn_dct_h  = ",nn_dct_h
+           WRITE(numout,*) "       Frequency of hourly write hard coded to every hour: nn_dctwri_h = ",nn_dctwri_h
+        ELSE
+           WRITE(numout,*) "       Frequency of computation: nn_dct    = ",nn_dct
+           WRITE(numout,*) "       Frequency of write:       nn_dctwri = ",nn_dctwri
+        ENDIF
 
         IF      ( nn_secdebug .GE. 1 .AND. nn_secdebug .LE. nb_sec_max )THEN
@@ -174,15 +213,26 @@
      !Read section_ijglobal.diadct
      CALL readsec
+     
+     !IF (lwp) write(numout,*) 'dct after readsec'
+     
 
      !open output file
-     IF( lwm ) THEN
-        CALL ctl_opn( numdct_vol,  'volume_transport', 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
-        CALL ctl_opn( numdct_heat, 'heat_transport'  , 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
-        CALL ctl_opn( numdct_salt, 'salt_transport'  , 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
+     IF( lwp ) THEN
+        IF( ln_NOOS ) THEN
+           CALL ctl_opn( numdct_NOOS  ,'NOOS_transport'  , 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
+           CALL ctl_opn( numdct_NOOS_h,'NOOS_transport_h', 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
+        ELSE
+           CALL ctl_opn( numdct_vol , 'volume_transport', 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
+           CALL ctl_opn( numdct_temp, 'heat_transport'  , 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
+           CALL ctl_opn( numdct_sal , 'salt_transport'  , 'NEW', 'FORMATTED', 'SEQUENTIAL', -1, numout,  .FALSE. )
+        ENDIF
      ENDIF
 
-     ! Initialise arrays to zero 
-     transports_3d(:,:,:,:)=0.0 
-     transports_2d(:,:,:)  =0.0 
+     ! Initialise arrays to zero
+     transports_3d(:,:,:,:)  =0._wp
+     transports_2d(:,:,:)    =0._wp
+     transports_3d_h(:,:,:,:)=0._wp
+     transports_2d_h(:,:,:)  =0._wp
+     z_hr_output(:,:,:)      =0._wp
 
      IF( nn_timing == 1 )   CALL timing_stop('dia_dct_init')
@@ -195,16 +245,16 @@
      !!               ***  ROUTINE diadct  ***  
      !!
-     !!  Purpose :: Compute section transports and write it in numdct files 
-     !!   
-     !!  Method  :: All arrays initialised to zero in dct_init 
-     !!             Each nn_dct time step call subroutine 'transports' for 
-     !!               each section to sum the transports over each grid cell. 
-     !!             Each nn_dctwri time step: 
-     !!               Divide the arrays by the number of summations to gain 
-     !!               an average value 
-     !!               Call dia_dct_sum to sum relevant grid boxes to obtain 
-     !!               totals for each class (density, depth, temp or sal) 
-     !!               Call dia_dct_wri to write the transports into file 
-     !!               Reinitialise all relevant arrays to zero 
+     !!  Purpose :: Compute section transports and write it in numdct files
+     !!  
+     !!  Method  :: All arrays initialised to zero in dct_init
+     !!             Each nn_dct time step call subroutine 'transports' for
+     !!               each section to sum the transports.
+     !!             Each nn_dctwri time step:
+     !!               Divide the arrays by the number of summations to gain
+     !!               an average value
+     !!               Call dia_dct_sum to sum relevant grid boxes to obtain
+     !!               totals for each class (density, depth, temp or sal)
+     !!               Call dia_dct_wri to write the transports into file
+     !!               Reinitialise all relevant arrays to zero
      !!---------------------------------------------------------------------
      !! * Arguments
@@ -213,19 +263,28 @@
      !! * Local variables
      INTEGER             :: jsec,            &! loop on sections
-                            itotal            ! nb_sec_max*nb_type_class*nb_class_max
+                            itotal            ! nb_sec_max*nb_type*nb_class_max
      LOGICAL             :: lldebug =.FALSE.  ! debug a section  
-     
-     INTEGER , DIMENSION(1)             :: ish   ! tmp array for mpp_sum
-     INTEGER , DIMENSION(3)             :: ish2  !   "
-     REAL(wp), POINTER, DIMENSION(:)    :: zwork !   "  
-     REAL(wp), POINTER, DIMENSION(:,:,:):: zsum  !   "
+
+     
+     INTEGER , DIMENSION(1)             :: ish      ! tmp array for mpp_sum
+     INTEGER , DIMENSION(3)             :: ish2     !   "
+     REAL(wp), POINTER, DIMENSION(:)    :: zwork    !   " 
+     REAL(wp), POINTER, DIMENSION(:,:,:):: zsum     !   "
+
+
 
      !!---------------------------------------------------------------------    
+     
+     
+     !WRITE(numout,*) "diadct ind ii: ",kt,nproc, narea, mig(1),mig(jpi),nlci
+     !WRITE(numout,*) "diadct ind jj: ",kt,nproc, narea, mjg(1),mig(jpj),nlcj
+
+     
      IF( nn_timing == 1 )   CALL timing_start('dia_dct')
 
      IF( lk_mpp )THEN
-        itotal = nb_sec_max*nb_type_class*nb_class_max
-        CALL wrk_alloc( itotal                                , zwork ) 
-        CALL wrk_alloc( nb_sec_max,nb_type_class,nb_class_max , zsum  )
+        itotal = nb_sec_max*nb_type*nb_class_max
+        CALL wrk_alloc( itotal                          , zwork ) 
+        CALL wrk_alloc( nb_sec_max,nb_type,nb_class_max , zsum  )
      ENDIF    
  
@@ -239,13 +298,19 @@
          WRITE(numout,*) "~~~~~~~~~~~~~~~~~~~~~~~~~"
          WRITE(numout,*) "nb_sec = ",nb_sec
+         WRITE(numout,*) "nn_dct = ",nn_dct
+         WRITE(numout,*) "ln_NOOS = ",ln_NOOS
+         WRITE(numout,*) "nb_sec = ",nb_sec
+         WRITE(numout,*) "nb_sec_max = ",nb_sec_max
+         WRITE(numout,*) "nb_type = ",nb_type
+         WRITE(numout,*) "nb_class_max = ",nb_class_max
      ENDIF
 
  
      ! Compute transport and write only at nn_dctwri
-     IF( MOD(kt,nn_dct)==0 ) THEN 
+     IF ( MOD(kt,nn_dct)==0 .or. &               ! compute transport every nn_dct time steps
+         (ln_NOOS .and. kt==nn_it000 ) )  THEN   ! also include first time step when calculating NOOS 25 hour averages
 
         DO jsec=1,nb_sec
 
-           !debug this section computing ?
            lldebug=.FALSE.
            IF( (jsec==nn_secdebug .OR. nn_secdebug==-1) .AND.  kt==nit000+nn_dct-1 .AND. lwp ) lldebug=.TRUE. 
@@ -253,24 +318,28 @@
            !Compute transport through section  
            CALL transport(secs(jsec),lldebug,jsec) 
+           
+           !IF( lwp ) WRITE(numout,*) "diadct: call transport subroutine (kt, jsec) : ",kt,jsec
 
         ENDDO
+        !IF( lwp ) WRITE(numout,*) "diadct: called transport subroutine (kt, nb_sec) : ",kt, nb_sec
              
         IF( MOD(kt,nn_dctwri)==0 )THEN
 
-           IF( lwp .AND. kt==nit000+nn_dctwri-1 )WRITE(numout,*)"      diadct: average transports and write at kt = ",kt         
+           IF( lwp .AND. kt==nit000+nn_dctwri-1 )WRITE(numout,*)"      diadct: average and write at kt = ",kt         
   
-           !! divide arrays by nn_dctwri/nn_dct to obtain average 
-           transports_3d(:,:,:,:)=transports_3d(:,:,:,:)/(nn_dctwri/nn_dct) 
-           transports_2d(:,:,:)  =transports_2d(:,:,:)  /(nn_dctwri/nn_dct) 
- 
-           ! Sum over each class 
-           DO jsec=1,nb_sec 
-              CALL dia_dct_sum(secs(jsec),jsec) 
-           ENDDO 
-
+           !! divide arrays by nn_dctwri/nn_dct to obtain average
+           transports_3d(:,:,:,:)=transports_3d(:,:,:,:)/(nn_dctwri/nn_dct)
+           transports_2d(:,:,:)  =transports_2d(:,:,:)  /(nn_dctwri/nn_dct)
+
+           ! Sum over each class
+           DO jsec=1,nb_sec
+              CALL dia_dct_sum(secs(jsec),jsec)
+           ENDDO
+ 
            !Sum on all procs 
            IF( lk_mpp )THEN
-              ish(1)  =  nb_sec_max*nb_type_class*nb_class_max 
-              ish2    = (/nb_sec_max,nb_type_class,nb_class_max/)
+              zsum(:,:,:)=0.0_wp
+              ish(1)  =  nb_sec_max*nb_type*nb_class_max 
+              ish2    = (/nb_sec_max,nb_type,nb_class_max/)
               DO jsec=1,nb_sec ; zsum(jsec,:,:) = secs(jsec)%transport(:,:) ; ENDDO
               zwork(:)= RESHAPE(zsum(:,:,:), ish )
@@ -283,10 +352,13 @@
            DO jsec=1,nb_sec
 
-              IF( lwm )CALL dia_dct_wri(kt,jsec,secs(jsec))
+              IF( lwp .and. .not. ln_NOOS )CALL dia_dct_wri(kt,jsec,secs(jsec))
+              IF( lwp .and.       ln_NOOS )CALL dia_dct_wri_NOOS(kt,jsec,secs(jsec))   ! use NOOS specific formatting
+            
             
               !nullify transports values after writing
-              transports_3d(:,jsec,:,:)=0.
-              transports_2d(:,jsec,:  )=0.
+              transports_3d(:,jsec,:,:)=0.0
+              transports_2d(:,jsec,:  )=0.0
               secs(jsec)%transport(:,:)=0.  
+              IF ( ln_NOOS ) CALL transport(secs(jsec),lldebug,jsec)  ! reinitialise for next 25 hour instantaneous average (overlapping values)
 
            ENDDO
@@ -295,9 +367,66 @@
 
      ENDIF
+     IF ( MOD(kt,nn_dct_h)==0 ) THEN            ! compute transport every nn_dct_h time steps
+     !IF ( MOD(kt,nn_dct)==0 .or. &               ! compute transport every nn_dct time steps
+     !    (ln_NOOS .and. kt==nn_it000 ) )  THEN   ! also include first time step when calculating NOOS 25 hour averages
+
+        DO jsec=1,nb_sec
+
+           lldebug=.FALSE.
+           IF( (jsec==nn_secdebug .OR. nn_secdebug==-1) .AND.  kt==nit000+nn_dct_h-1 .AND. lwp ) lldebug=.TRUE. 
+
+           !Compute transport through section  
+           CALL transport_h(secs(jsec),lldebug,jsec) 
+
+        ENDDO
+             
+        IF( MOD(kt,nn_dctwri_h)==0 )THEN
+
+           IF( lwp .AND. kt==nit000+nn_dctwri_h-1 )WRITE(numout,*)"      diadct: average and write hourly files at kt = ",kt         
+  
+           !! divide arrays by nn_dctwri/nn_dct to obtain average
+           transports_3d_h(:,:,:,:)=transports_3d_h(:,:,:,:)/(nn_dctwri_h/nn_dct_h)
+           transports_2d_h(:,:,:)  =transports_2d_h(:,:,:)  /(nn_dctwri_h/nn_dct_h)
+
+           ! Sum over each class
+           DO jsec=1,nb_sec
+              CALL dia_dct_sum_h(secs(jsec),jsec)
+           ENDDO
+ 
+           !Sum on all procs 
+          IF( lk_mpp )THEN
+              ish(1)  =  nb_sec_max*nb_type*nb_class_max 
+              ish2    = (/nb_sec_max,nb_type,nb_class_max/)
+              DO jsec=1,nb_sec ; zsum(jsec,:,:) = secs(jsec)%transport_h(:,:) ; ENDDO
+              zwork(:)= RESHAPE(zsum(:,:,:), ish )
+              CALL mpp_sum(zwork, ish(1))
+              zsum(:,:,:)= RESHAPE(zwork,ish2)
+              DO jsec=1,nb_sec ; secs(jsec)%transport_h(:,:) = zsum(jsec,:,:) ; ENDDO
+           ENDIF
+
+           !Write the transport
+           DO jsec=1,nb_sec
+
+              IF( lwp .and. ln_NOOS ) THEN
+                !WRITE(numout,*) "diadct: call dia_dct_wri_NOOS_h (kt,nn_dctwri_h, kt/nn_dctwri_h,jsec) : ",kt,nn_dctwri_h, kt/nn_dctwri_h,jsec
+                CALL dia_dct_wri_NOOS_h(kt/nn_dctwri_h,jsec,secs(jsec))   ! use NOOS specific formatting
+                !WRITE(numout,*) "diadct: called dia_dct_wri_NOOS_h (kt,jsec) : ",kt,jsec
+              endif
+              !nullify transports values after writing
+              transports_3d_h(:,jsec,:,:)=0.0
+              transports_2d_h(:,jsec,:)=0.0
+              secs(jsec)%transport_h(:,:)=0.  
+              IF ( ln_NOOS ) CALL transport_h(secs(jsec),lldebug,jsec)  ! reinitialise for next 25 hour instantaneous average (overlapping values)
+
+           ENDDO
+
+        ENDIF 
+
+     ENDIF    
 
      IF( lk_mpp )THEN
-        itotal = nb_sec_max*nb_type_class*nb_class_max
-        CALL wrk_dealloc( itotal                                , zwork ) 
-        CALL wrk_dealloc( nb_sec_max,nb_type_class,nb_class_max , zsum  )
+        itotal = nb_sec_max*nb_type*nb_class_max
+        CALL wrk_dealloc( itotal                          , zwork ) 
+        CALL wrk_dealloc( nb_sec_max,nb_type,nb_class_max , zsum  )
      ENDIF    
 
@@ -320,4 +449,5 @@
      INTEGER :: isec, iiglo, ijglo, iiloc, ijloc,iost,i1 ,i2  ! temporary  integer
      INTEGER :: jsec, jpt                                     ! dummy loop indices
+                                                              ! heat/salt tranport is actived
 
      INTEGER, DIMENSION(2) :: icoord 
@@ -336,6 +466,27 @@
      !open input file
      !---------------
-     CALL ctl_opn( numdct_in, 'section_ijglobal.diadct', 'OLD', 'UNFORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
- 
+     !IF (lwp) THEN
+       !write(numout,*) 'dct low-level pre open: little endian '
+       !OPEN(UNIT=107,FILE='section_ijglobal.diadct', FORM='UNFORMATTED', ACCESS='SEQUENTIAL', STATUS='OLD',convert='LITTLE_ENDIAN')
+       
+       write(numout,*) 'dct low-level pre open: big endian :',nproc,narea
+       OPEN(UNIT=107,FILE='section_ijglobal.diadct', FORM='UNFORMATTED', ACCESS='SEQUENTIAL', STATUS='OLD',convert='BIG_ENDIAN')
+       
+       !write(numout,*) 'dct low-level pre open: SWAP '
+       !OPEN(UNIT=107,FILE='section_ijglobal.diadct', FORM='UNFORMATTED', ACCESS='SEQUENTIAL', STATUS='OLD',convert='SWAP')
+       
+       !write(numout,*) 'dct low-level pre open: NATIVE '
+       !OPEN(UNIT=107,FILE='section_ijglobal.diadct', FORM='UNFORMATTED', ACCESS='SEQUENTIAL', STATUS='OLD',convert='NATIVE')
+       
+       write(numout,*) 'dct low-level opened :',nproc,narea
+       READ(107) isec
+       write(numout,*) 'dct low-level isec ', isec,nproc,narea
+       CLOSE(107)
+     !ENDIF
+     
+     
+     CALL ctl_opn( numdct_in, 'section_ijglobal.diadct', 'OLD', 'UNFORMATTED', 'SEQUENTIAL', -1, numout, .TRUE. )
+ 
+     
      !---------------
      !Read input file
@@ -350,19 +501,55 @@
         !---------------
         secs(jsec)%name=''
-        secs(jsec)%llstrpond    = .FALSE.  ; secs(jsec)%ll_ice_section = .FALSE.
-        secs(jsec)%ll_date_line = .FALSE.  ; secs(jsec)%nb_class       = 0
-        secs(jsec)%zsigi        = 99._wp   ; secs(jsec)%zsigp          = 99._wp
-        secs(jsec)%zsal         = 99._wp   ; secs(jsec)%ztem           = 99._wp
-        secs(jsec)%zlay         = 99._wp         
-        secs(jsec)%transport    =  0._wp   ; secs(jsec)%nb_point       = 0
+        !IF( lwp )  write(numout,*)  secs(jsec)%name
+        secs(jsec)%llstrpond      = .FALSE.
+        !IF( lwp )  write(numout,*) secs(jsec)%llstrpond 
+        secs(jsec)%ll_ice_section = .FALSE.
+        !IF( lwp )  write(numout,*) secs
+        secs(jsec)%ll_date_line   = .FALSE.
+        !IF( lwp )  write(numout,*) secs(jsec)%ll_date_line
+        secs(jsec)%nb_class       = 0
+        !IF( lwp )  write(numout,*) secs(jsec)%nb_class
+        secs(jsec)%zsigi          = 99._wp
+        !IF( lwp )  write(numout,*) secs(jsec)%zsigi
+        secs(jsec)%zsigp          = 99._wp
+        !IF( lwp )  write(numout,*)  secs(jsec)%zsigp
+        secs(jsec)%zsal           = 99._wp
+        !IF( lwp )  write(numout,*) secs(jsec)%zsal
+        secs(jsec)%ztem           = 99._wp
+        !IF( lwp )  write(numout,*) secs(jsec)%ztem
+        secs(jsec)%zlay           = 99._wp
+        !IF( lwp )  write(numout,*) secs(jsec)%zlay
+        secs(jsec)%transport      =  0._wp
+        !IF( lwp )  write(numout,*) secs(jsec)%transport
+        secs(jsec)%transport_h    =  0._wp
+        !IF( lwp )  write(numout,*) secs(jsec)%transport_h
+        secs(jsec)%nb_point       = 0
+        !IF( lwp )  write(numout,*) secs(jsec)%nb_point 
 
         !read section's number / name / computing choices / classes / slopeSection / points number
         !-----------------------------------------------------------------------------------------
-        READ(numdct_in,iostat=iost)isec
-        IF (iost .NE. 0 )EXIT !end of file 
+        
+        !write(numout,*) 'dct isec ', isec
+        !write(numout,*) 'dct numdct_in ', numdct_in
+        READ(numdct_in,iostat=iost) isec
+        !write(numout,*) 'dct iost ', iost
+        !IF (iost .NE. 0 ) EXIT
+        IF (iost .NE. 0 ) then
+          write(numout,*) 'unable to read section_ijglobal.diadct. iost = ',iost
+          !nb_sec = 2
+          EXIT !end of file 
+        ENDIF
+        
+        !write(numout,*) 'dct isec', isec
+        
         WRITE(cltmp,'(a,i4.4,a,i4.4)')'diadct: read sections : Problem of section number: isec= ',isec,' and jsec= ',jsec
+        !WRITE(numout,'(a,i4.4,a,i4.4)')'diadct: read sections : Problem of section number: isec= ',isec,' and jsec= ',jsec
+        
+        !write(numout,*) 'dct isec, jsec', isec,jsec
+        
+        
         IF( jsec .NE. isec )  CALL ctl_stop( cltmp )
 
-        IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )WRITE(numout,*)"isec ",isec 
+        !IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )WRITE(numout,*)"isec ",isec 
 
         READ(numdct_in)secs(jsec)%name
@@ -388,5 +575,5 @@
 
             WRITE(numout,*)       "   Section name :                       ",TRIM(secs(jsec)%name)
-            WRITE(numout,*)       "      Compute heat and salt transport ? ",secs(jsec)%llstrpond
+            WRITE(numout,*)       "      Compute temperature and salinity transports ? ",secs(jsec)%llstrpond
             WRITE(numout,*)       "      Compute ice transport ?           ",secs(jsec)%ll_ice_section
             WRITE(numout,*)       "      Section crosses date-line ?       ",secs(jsec)%ll_date_line
@@ -399,5 +586,6 @@
             WRITE(numout,clformat)"      Temperature classes :             ",secs(jsec)%ztem
             WRITE(numout,clformat)"      Depth classes :                   ",secs(jsec)%zlay
-        ENDIF               
+        ENDIF     
+        
 
         IF( iptglo .NE. 0 )THEN
@@ -411,4 +599,5 @@
               coordtemp(jpt)%I = i1 
               coordtemp(jpt)%J = i2
+              !WRITE(numout,*)'diadct: coordtemp:', jpt,i1,i2
            ENDDO
            READ(numdct_in)directemp(1:iptglo)
@@ -432,11 +621,29 @@
 
               IF( iiglo==jpidta .AND. nimpp==1 ) iiglo = 2
-
+              
+              !WRITE(numout,*)"diadct readsec: reg/glo domain:",narea,nlci,nimpp,mig(1),nlcj,njmpp,mjg(1)
+
+      !diadct init: reg/glo domain: 3*1,  24,  22,  24,  22,  2*1
               iiloc=iiglo-jpizoom+1-nimpp+1   ! local coordinates of the point
               ijloc=ijglo-jpjzoom+1-njmpp+1   !  "
-
+              !WRITE(numout,*)"      List of limits of each processor:",jpt,nimpp,iiloc,iiglo,jpizoom+1,nimpp+1,ijloc,ijglo,jpjzoom+1,njmpp+1,nlei,nlej
+
+               
+              !WRITE(*,*)"diadct readsec: ii: ",narea, jpt,iiglo,mig(1),mig(jpi),nlci
+              !WRITE(*,*)"diadct readsec: jj: ",narea, jpt,ijglo,mjg(1),mjg(jpj),nlcj
+              !WRITE(*,*)"diadct readsec: log: ",narea, iiglo .GE. mig(1),iiglo .LE. mig(1)+nlci-1 ,ijglo .GE. mjg(1),ijglo .LE. mjg(1)+nlcj-1  
+              !WRITE(*,*)"diadct readsec: log: ",narea, iiglo .GE. mig(1),iiglo .LE. mig(jpi),ijglo .GE. mjg(1),ijglo .LE. mjg(jpj)
               !verify if the point is on the local domain:(1,nlei)*(1,nlej)
               IF( iiloc .GE. 1 .AND. iiloc .LE. nlei .AND. &
                   ijloc .GE. 1 .AND. ijloc .LE. nlej       )THEN
+              !IF( iiglo .GE. mig(1) .AND. iiglo .LE. mig(1)+nlci-1 .AND. &
+              !    ijglo .GE. mjg(1) .AND. ijglo .LE. mjg(1)+nlcj-1       )THEN
+                  
+                  
+              !IF( iiglo .GE. mig(1) .AND. iiglo .LE. mig(jpi) .AND. &
+              !    ijglo .GE. mjg(1) .AND. ijglo .LE. mjg(jpj)       )THEN
+                  WRITE(*,*)"diadct readsec: assigned proc!",narea,nproc,jpt
+                  
+                  
                  iptloc = iptloc + 1                                                 ! count local points
                  secs(jsec)%listPoint(iptloc) = POINT_SECTION(mi0(iiglo),mj0(ijglo)) ! store local coordinates
@@ -459,10 +666,10 @@
            ENDIF
 
-              IF(jsec==nn_secdebug .AND. secs(jsec)%nb_point .NE. 0)THEN
+           IF(jsec==nn_secdebug .AND. secs(jsec)%nb_point .NE. 0)THEN
               DO jpt = 1,iptloc
                  iiglo = secs(jsec)%listPoint(jpt)%I + jpizoom - 1 + nimpp - 1
                  ijglo = secs(jsec)%listPoint(jpt)%J + jpjzoom - 1 + njmpp - 1
               ENDDO
-              ENDIF
+           ENDIF
 
            !remove redundant points between processors
@@ -501,8 +708,13 @@
 
      ENDDO !end of the loop on jsec
+     
+     !IF (lwp) write(numout,*) 'dct end of readsec loop, after exit'
  
      nb_sec = jsec-1   !number of section read in the file
 
      CALL wrk_dealloc( nb_point_max, directemp )
+     
+     !IF (lwp) write(numout,*) 'dct after dealloc'
+     
      !
   END SUBROUTINE readsec
@@ -586,4 +798,5 @@
      CALL wrk_dealloc(    nb_point_max, idirec )
      CALL wrk_dealloc( 2, nb_point_max, icoord )
+
   END SUBROUTINE removepoints
 
@@ -592,18 +805,18 @@
      !!                     ***  ROUTINE transport  ***
      !!
-     !!  Purpose ::  Compute the transport for each point in a section 
+     !!  Purpose ::  Compute the transport for each point in a section
+     !!
+     !!  Method  ::  Loop over each segment, and each vertical level and add the transport
+     !!              Be aware :          
+     !!              One section is a sum of segments
+     !!              One segment is defined by 2 consecutive points in sec%listPoint
+     !!              All points of sec%listPoint are positioned on the F-point of the cell
      !! 
-     !!  Method  ::  Loop over each segment, and each vertical level and add the transport 
-     !!              Be aware :           
-     !!              One section is a sum of segments 
-     !!              One segment is defined by 2 consecutive points in sec%listPoint 
-     !!              All points of sec%listPoint are positioned on the F-point of the cell 
-     !! 
-     !!              There are two loops:                  
-     !!              loop on the segment between 2 nodes 
-     !!              loop on the level jk !!
-     !! 
-     !!  Output  ::  Arrays containing the volume,density,heat,salt transports for each i
-     !!              point in a section, summed over each nn_dct. 
+     !!              There are two loops:                 
+     !!              loop on the segment between 2 nodes
+     !!              loop on the level jk
+     !!
+     !! ** Output: Arrays containing the volume,density,salinity,temperature etc
+     !!            transports for each point in a section, summed over each nn_dct.
      !!
      !!-------------------------------------------------------------------------------------------
@@ -614,15 +827,15 @@
     
      !! * Local variables
-     INTEGER             :: jk, jseg, jclass,jl,                 &!loop on level/segment/classes/ice categories
-                            isgnu, isgnv                          ! 
-     REAL(wp)            :: zumid, zvmid,                        &!U/V velocity on a cell segment 
-                            zumid_ice, zvmid_ice,                &!U/V ice velocity 
-                            zTnorm                                !transport of velocity through one cell's sides 
-     REAL(wp)            :: ztn, zsn, zrhoi, zrhop, zsshn, zfsdep !temperature/salinity/potential density/ssh/depth at u/v point
+     INTEGER             :: jk,jseg,jclass,    &!loop on level/segment/classes 
+                            isgnu  , isgnv      !
+     REAL(wp):: zumid        , zvmid        ,  &!U/V velocity on a cell segment
+                zumid_ice    , zvmid_ice    ,  &!U/V ice velocity
+                zTnorm                          !transport of velocity through one cell's sides
+     REAL(wp):: ztn, zsn, zrhoi, zrhop, zsshn, zfsdep ! temperature/salinity/ssh/potential density /depth at u/v point
 
      TYPE(POINT_SECTION) :: k
      !!--------------------------------------------------------
 
-     IF( ld_debug )WRITE(numout,*)'      Compute transport'
+     IF( ld_debug )WRITE(numout,*)'      Compute transport (jsec,sec%nb_point,sec%slopeSection) : ', jsec,sec%nb_point,sec%slopeSection
 
      !---------------------------!
